package eu.clarin.cmdi.mdservice.action;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import eu.clarin.cmdi.mdservice.internal.Cache;
import eu.clarin.cmdi.mdservice.internal.Utils;
import eu.clarin.cmdi.mdservice.model.Diagnostic;
import eu.clarin.cmdi.mdservice.model.Query;
import eu.clarin.cmdi.mdservice.model.Repositories;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;
import eu.clarin.cmdi.mdservice.proxy.MDRepoProxy;
import eu.clarin.cmdi.mdservice.proxy.Pz2Proxy;
import eu.clarin.cmdi.mdservice.proxy.SRUProxy;




public class SRUAction extends RepoAction 
{

	private static final long serialVersionUID = 1L;
	
	/** 
	 * Properties to be filled by Struts with according request-parameters
	 */	
	/*
	private String q;
	private String version;
	private String operation;
	private String query;
	private String scanClause;
	private int startRecord;
	private int maximumRecords;
	private String recordPacking;
	private String recordSchema;
	private String recordXPath;
	private int resultSetTTL;
	private String sortKeys;
	private String stylesheet;	
	private String x_cmd_repository;
	private String x_cmd_collections;
	private Set paramSet;
*/
	
	private static int OP_SEARCHRETRIEVE = 1;
	private static int OP_EXPLAIN = 2;
	private static int OP_SCAN = 3;
	
	
	//TODO cache after analysis ?
	@Override
	public String getCache() {
		return Cache.SKIP;
	}
	
	@Override
	public String getRepository() {
		if (getParams().get("repository") == null){
			return getParam("x-cmd-repository");
		}
		return getParam("repository");
	}
	
	@Override
	public String getFormat() {
		if (getParams().get("format") == null){
			if (getParams().get("x-cmd-format") == null){
				return "xml";
			}
			return getParam("x-cmd-format");
		}
		return getParam("format");
	}
	
	public String getOperation() {
		if (getParams().get("operation") == null){
			return "searchRetrieve";
		}
		return getParam("operation");
	}
	
	 protected final static HashMap<String,Integer> operation_code = new HashMap<String,Integer>();
	 static
	 {	 
		 operation_code.put("searchRetrieve", OP_SEARCHRETRIEVE);
		 operation_code.put("explain", OP_EXPLAIN);
		 operation_code.put("scan", OP_SCAN);
	 }
	 
	/**
	 * primitive identification of the target-proxy
	 * base for finding the right base_url in the props
	 * subclass has to override with its specific proxykey
	 * @return
	 */
	public String getProxyKey() {
		return "";
	}
/*
	@Override
	protected void setDefaultParams() {		
		// set defaults
	/*	if ( params.get("version") == null){
			addParam("version","1.2");
		}
		if ( params.get("operation") == null){
			addParam("operation","searchRetrieve");
		}
		//q=query			
		if (getQ() != null) {
			addParam("q",getQ());
			addParam("query",getQ());
		} else {
			addParam("q",this.getParam("query"));
		}
		
		if ( params.get("startRecord") == null){
			addParam("startRecord","1");
		}
		if ( params.get("maximumRecords") == null){
			addParam("maximumRecords","50");
		}
		
		if ( params.get("x-cmd-maxdepth") == null){
			if (params.get("maxdepth") == null){
				addParam("maxdepth","2");
			} 
		} else {
			addParam("maxdepth",params.get("x-cmd-maxdepth")[0]);
		}
		
		if ( params.get("x-cmd-repository") == null){
			if (params.get("repository") == null){
				addParam("repository",WorkspaceProfile.getRepositoryByIndex(0));
			} 
		} else {
			addParam("repository",params.get("x-cmd-repository")[0]);
		}
		
		if ( params.get("x-cmd-cache") == null){
			if (params.get("cache") == null){
				addParam("cache",Cache.SKIP);
			} 
		} else {
			addParam("cache",params.get("x-cmd-cache")[0]);
		}
		
		if ( params.get("x-cmd-lang") == null){
			if (params.get("lang") == null){
				addParam("lang","en");
			} 
		} else {
			addParam("lang",params.get("x-cmd-lang")[0]);
		}
		
		if ( params.get("x-cmd-format") == null){
			if (params.get("format") == null){
				if (this.format == null) {
					addParam("format","xml");
				} else if (this.format.equals("")){
					addParam("format","xml");
				} else {
					addParam("format",this.format);
				}
			} 
		} else {
			addParam("format",params.get("x-cmd-format")[0]);
		}

		addParam("fullformat",getFullFormat());
		
	}
*/
	/* 
	public void prepareOperation() throws UnsupportedEncodingException{
		
		mdrepoproxyaction = new MDRepoProxyAction();
		mdrepoproxyaction.setDiagnostics(diagnostics);
		mdrepoproxyaction.setActionkey(hash_operations.get(this.getOperation()));
		
		// set the SRU extern property in proxyaction
		if (this.getX_cmd_repository() != null ) {
			mdrepoproxyaction.setRepository(this.getX_cmd_repository());
			//TODO\
			if (mdrepoproxyaction.getBaseURI() == null) this.Diagnostics().Add(Diagnostic.UNSUPPORTED_PARAMETERVALUE, "Unknown repository." + getX_cmd_repository());
		}
		
		if (operation.equals("searchRetrieve")){
			
			//query
			mdrepoproxyaction.setSquery("");
			if (this.query == null) {
				this.Diagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "query");
				//return -1;
			}
			mdrepoproxyaction.setQ(getQuery());			
			mdrepoproxyaction.setFormat("xml");
			
			if ((this.startRecord < 0 ) ||((getServletRequest().getParameter("startRecord") != null)&&(getServletRequest().getParameter("startRecord").equals("0")))) {
				this.Diagnostics().Add(new Diagnostic(Diagnostic.UNSUPPORTED_PARAMETERVALUE, "startRecord must by grater than 0."));//,Diagnostic.NONFATALNONSURORGATE));
				//mdrepoproxyaction.setStartItem("1");
			} else {
				mdrepoproxyaction.setStartItem(Integer.toString(getStartRecord()));
			}
		
			if ((this.maximumRecords < 0 ) ||((getServletRequest().getParameter("maximumRecords") != null) && (getServletRequest().getParameter("maximumRecords").equals("0")))){
				   this.Diagnostics().Add(new Diagnostic(Diagnostic.UNSUPPORTED_PARAMETERVALUE, 
						   "maximumRecords must by greater than 0."));
			} else {
				mdrepoproxyaction.setMaximumItems(Integer.toString(this.getMaximumRecords()));	
			}
			
			if (this.getX_cmd_repository() != null ) {
				mdrepoproxyaction.setRepository(this.getX_cmd_repository());
				//TODO\
				if (mdrepoproxyaction.getBaseURI() == null) this.Diagnostics().Add(Diagnostic.UNSUPPORTED_PARAMETERVALUE, "Unknown repository." + getX_cmd_repository());
			}
			if (this.getX_cmd_collections() != null ) {
				mdrepoproxyaction.setCollection(this.getX_cmd_collections());
			}

		} else {
			if (operation.equals("explain") || operation == null){
				log.debug("explaining", "debug");
			}else {
				if (operation.equals("scan")){
					if (this.scanClause == null) {
						this.Diagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "scanClause");
						//return -1;
					} else{
						if (this.scanClause.equals("cmd.Collections")){
							
						} else {
							if (this.scanClause.equals("cmd.Repository")){
								XMLSerializer xmlserializer = new XMLSerializer();
								String xml = xmlserializer.write( WorkspaceProfile.getRepositories());//mdrepoproxyaction.getRepositories() );  
								this.setResultStream(new ByteArrayInputStream(xml.getBytes("UTF-8"))); 

							} else {
								
							}
						}
					}
				}else {
					this.Diagnostics().Add(Diagnostic.UNSUPPOERTED_OPERATION, "Only searchRetrieve,explain scan supported.");				}
			}
		}
	}
	
	public void sru2MD() throws UnsupportedEncodingException{
		// special handling of parameter setting, x-cmd-... not alowed in java
		this.setX_cmd_collections(getServletRequest().getParameter("x-cmd-collections"));		
		// root call own SRU SERVER
		//operation
		if (operation.equals("explain") || operation == null){
			// TODO: version param is mandatory for explain as well, but for root-request not!
			//explain
			termsproxyaction = new TermsProxyAction();
			termsproxyaction.setDiagnostics(diagnostics);
			termsproxyaction.setActionkey("terms");
			
			termsproxyaction.setQ("all");			
			termsproxyaction.setFormat("sru-explain");			
			
			//return -1;
		} else {				
			//version		
			if (this.version == null) {
				this.Diagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "version");
				//return -1;
			} else {
				if (!version.equals("1.2")) {
					this.Diagnostics().Add(Diagnostic.UNSUPPORTED_VERSION, "Version 1.2 supported.");
					//return -1;
				}
			}
			
			prepareOperation();
		}
		
	}
	
	public void  prepareMD() throws Exception{
		sru2MD();
		if (Diagnostics().Accepted()){
			// root-explain
			if (this.termsproxyaction != null) {			
				if (this.termsproxyaction.execute() == SUCCESS){
					this.setResultStream(this.termsproxyaction.getResultStream());
					//return SUCCESS;
				}
			} else {
				//TODO diagnostic			 
				if (this.mdrepoproxyaction.getTargetRequest() == null) {
					Diagnostics().Add(Diagnostic.QUERYSYNTAXERROR);
					//return ERROR;
				}
				if (this.mdrepoproxyaction.execute() == SUCCESS){
					this.setResultStream(this.mdrepoproxyaction.getResultStream());
					postprocess();
					//return SUCCESS;
				}
			}
		}
		//return ERROR;
	}
	*/
/** TODO: move to Utils
 * 
 * @param stream
 * @return
 * @throws IOException
 */
	/*
	public static String inputStreamAsString(InputStream stream)
		throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(stream));
		StringBuilder sb = new StringBuilder();
		String line = null;

		while ((line = br.readLine()) != null) {
		sb.append(line + "\n");
		}

		br.close();
		return sb.toString();
	}

	

	public void postprocess() throws TransformerConfigurationException, UnsupportedEncodingException, ParserConfigurationException, TransformerException, TransformerFactoryConfigurationError{
		//recordPacking
		if (this.getRecordPacking() != null){
			if (this.getRecordPacking().toLowerCase().equals("string")){
				
				try {
					// FIXME: Which package is IOUTils from? 
					this.setResultStream(IOUtils.toInputStream(StringEscapeUtils.escapeXml(inputStreamAsString(this.getResultStream()))));
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			}
		}
		
		// add diagnostics
		if (getDiagnostics().Exists()){
			Document doc = Utils.stream2Document(getResultStream());
			Node r_element=  doc.getElementsByTagName("searchRetrieveResponse").item(0);
			Document ddoc = getDiagnostics().buildXMLDocument();
			Node d_element=  ddoc.getElementsByTagName("diagnostics").item(0);
			doc.adoptNode(d_element);
			r_element.appendChild(d_element);
			DOMSource source = new DOMSource(doc);   
			StringWriter xmlAsWriter = new StringWriter();   
			StreamResult result = new StreamResult(xmlAsWriter);    
			TransformerFactory.newInstance().newTransformer().transform(source, result);
			this.setResultStream(new ByteArrayInputStream(xmlAsWriter.toString().getBytes("UTF-8")));
		}
	}
	
	//TODO create query + query.toURLParams ?
	public String createURLParams(){
		String params = "";
		
		//TODO params
		/*
		if (paramSet == null){
			if (!(operation == null)){
				params = params + "operation=" + operation;
			}
			if (!(version == null)){
				params = params + "&version=" + version;
			}
			if (!(query == null)){
				params = params + "&query=" + query;
			}
			if (getStartRecord() > 0){
				params = params + "&startRecord=" + String.valueOf(getStartRecord());
			}
			if (getMaximumRecords()> 0){
				params = params + "&numRecords=" + String.valueOf(getMaximumRecords());
			}
		} else {
			Iterator i = paramSet.iterator();
			params = "";
		    while(i.hasNext()){
			      Map.Entry me = (Map.Entry)i.next();
			      if (!(me.getKey().equals("x-cmd-repository") || me.getKey().equals("x-cmd-collections"))){
				      params = params + "&" + me.getKey() + "=" + ((String[])me.getValue())[0];  
			      }
			}
		    params = params.substring(1);

		}

		return params;
	}
*/	

/*	
	@Override 
	public void prepare() throws Exception{
		//this.setX_cmd_repository(getServletRequest().getParameter("x-cmd-repository"));
		//this.setRepository(this.getX_cmd_repository());
		//TODO xsl usage according particular repositories ?
		//this.setActionkey("sru");
		//this.setFormat("xml");
		
		//extern SRU repository
		if (WorkspaceProfile.isSRURepository(getRepository()) || this.getBaseURI() == null){
			super.prepare();
		}
		else {
			 prepareMD();
		}
		
	}
*/
	@Override
	public void setTargetProxy(){
		
		//Query query = new Query();
		switch (Repositories.RepositoryType.toRepositoryType(Repositories.getRepositories().getRepositoryType(getRepository())))
		{		
		    case PAZPAR: 
		    	setTargetProxy(new Pz2Proxy(new Query(getActionkey(), this.getParams())));
		    	return;
		    case SRU:
		    	setTargetProxy(new SRUProxy(new Query(Query.SRUEXTERN,getParams())));
		    	return;
		    case MD:
		    	setTargetProxy(new MDRepoProxy(new Query(Query.RECORDSET,getParams())));
		    	return;	
		    default:
		    	//TODO error  = bad workspaceProfile configuration
		    	getDiagnostics().Add(Diagnostic.SYSTEM_ERROR, "Error in workspaceprofile configuration", "repository=" + getRepository() );
		}
}
}