package eu.clarin.cmdi.mdservice.model;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;

import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import net.sf.json.JSON;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import net.sf.json.JSONSerializer;
import net.sf.json.xml.XMLSerializer;
import eu.clarin.cmdi.mdservice.internal.MDTransformer;
import eu.clarin.cmdi.mdservice.internal.Utils;
import eu.clarin.cmdi.mdservice.action.FCSAction;
import eu.clarin.cmdi.mdservice.action.WorkspaceAction;
import eu.clarin.cmdi.mdservice.action.WorkspaceAction_old;
import eu.clarin.cmdi.mdservice.internal.NoStylesheetException;

/**
 
 */



public class WorkspaceProfile{	

	private static WorkspaceProfile singleton;
	private static Document workspace_doc;
	
	private String workspacefilename;
	private String username;
	private String elementtype;
	private String qid;
	private String qsid;
	//TODO counter not working
	private static final Integer START_QUERY = 1;
	
	// save element type
	public static String SE_WORKSPACE = "workspace";
	public static String SE_QUERYSET = "queryset";
	public static String SE_QUERY = "query";
	public static String SE_BOOKMARKSET = "bookmarkset";
	public static String SE_BOOKMARK = "bookmark";
	
	public static String USER = "user";
	public static String SERVER = "server";
	
	public static String XPATH_EXPR_WORKSPACE = "//Profiles/WorkspaceProfiles/WorkspaceProfile[@user='dummy']";
	public static String XPATH_EXPR_REPOSITORIES = "//Profiles/WorkspaceProfiles/WorkspaceProfile[@user='server']/Repositories";
	public static String XPATH_EXPR_OPTIONS = "//Profiles/WorkspaceProfiles/WorkspaceProfile[@user='server']/Options";
	public static String XPATH_EXPR_TERMSETS = "//Profiles/WorkspaceProfiles/WorkspaceProfile[@user='server']/Termsets";
	public static String XPATH_EXPR_REPOPATH = "//Profiles/WorkspaceProfiles/WorkspaceProfile[@user='server']/Repositories/item[@name='dummy']/uri";
	public static String XPATH_EXPR_QUERY_PARENT = "//Profiles/WorkspaceProfiles/WorkspaceProfile/Querysets/item[id='dummy']/Queries";
	public static String XPATH_EXPR_QUERYSET = "//Profiles/WorkspaceProfiles/WorkspaceProfile/Querysets/item[id='dummy']";
	public static String XPATH_EXPR_WORKSPACE_QUERY = "//Profiles/WorkspaceProfiles/WorkspaceProfile/Querysets/item/Queries/item[id='dummy']";
	public static String XPATH_EXPR_BOOKMARKSET = "//Profiles/WorkspaceProfiles/WorkspaceProfile/Bookmarksets/item[id='dummy']";
	public static String XPATH_EXPR_BOOKMARK_PARENT = "//Profiles/WorkspaceProfiles/WorkspaceProfile/Bookmarksets/item[id='dummy']/Bookmarks";
	/////
	private static HashMap<String,String> fcs_mapping = null;
	
	
	public void setQsid(String qsid) {
		this.qsid = qsid;
	}

	public String getQsid() {
		return qsid;
	}

	public void setQid(String qid) {
		this.qid = qid;
	}

	public String getQid() {
		return qid;
	}

	public void setElementtype(String elementtype) {
		this.elementtype = elementtype;
	}

	public String getElementtype() {
		return elementtype;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getUsername() {
		return username;
	}

	public WorkspaceProfile() {
		Init();
	}
	
	public static WorkspaceProfile getWorkspaceProfile() {
		if (singleton == null) {
			singleton = new WorkspaceProfile();
		} 
		return singleton;
	}
	
	public void Init(){
		//configure
		Utils.loadConfig("mdservice", "mdservice.properties", this.getClass().getClassLoader());
		workspacefilename = Utils.getConfig("workspaceprofile.path") + Utils.getConfig("workspace.file");
		username = SERVER;
		
		if (workspace_doc == null){
			initDocument();
		}
	}
	
	public void initDocument() {
		
		Integer counter = START_QUERY;
		File f = new File (workspacefilename);
			
		if (!f.exists()) {
					// create new  counter document
					DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		         	DocumentBuilder docBuilder;
					try {
						docBuilder = docFactory.newDocumentBuilder();
						workspace_doc = docBuilder.newDocument();
						// append root tag <index >
						Element root = (Element) workspace_doc.createElement("Profiles");
						//root.setAttribute("idcounter", "1");
						workspace_doc.appendChild(root);
						Element e = workspace_doc.createElement("Querycounter");
						root.appendChild(e);
						e = workspace_doc.createElement("maxqid");
						e.setNodeValue(counter.toString());
						e = workspace_doc.createElement("WorkspaceProfiles");
						root.appendChild(e);

						//updateQuerycounter();
						this.saveDocument();
						
						//log.debug("new document");
					} catch (ParserConfigurationException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
		    }
			else {
				try {
					
		         	DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		         	DocumentBuilder docBuilder;
					try {
						docBuilder = docFactory.newDocumentBuilder();		    
						try {
								workspace_doc = docBuilder.parse(f);//workspacefilename);
						} catch (SAXException e) {
								// TODO Auto-generated catch block
								
								e.printStackTrace();
						}
					} catch (ParserConfigurationException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
					}
			         	
			         //read counter
			         //counter = new Integer(workspace_doc.getFirstChild().getFirstChild().getFirstChild().getNodeValue());
			         //init = true;
			    }  catch (IOException ex){
			    	//log.debug("initCacheCounter:" + ex.toString());
			        ex.printStackTrace();
			    }
			}
			
		    //return counter;
		}

	public void saveDocument() {
		//public void writeQuerycounter (Integer i) {		
			
			// first update <index idcounter>
			//workspace_doc.getFirstChild().getAttributes().getNamedItem("idcounter").setNodeValue(i.toString());
			
			//log.debug("writeCacheCounter:" + i.toString());
			// write xml
			Transformer transformer;
			try {
				transformer = TransformerFactory.newInstance().newTransformer();
				transformer.setOutputProperty(OutputKeys.INDENT, "yes");

				//initialize StreamResult with File object to save to file
				StreamResult result = new StreamResult(new StringWriter());
				DOMSource source = new DOMSource(workspace_doc);
				try {
					transformer.transform(source, result);
				} catch (TransformerException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}

				String xmlString = result.getWriter().toString();

				File f = new File (workspacefilename);
				FileWriter fw;
				try {
					fw = new FileWriter(f);
					try {
						fw.write(xmlString);
						fw.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}	
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} catch (TransformerConfigurationException e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			} catch (TransformerFactoryConfigurationError e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}
	}
	
	public String getXPathExpressionDummy(String xpath_expr, String new_dummy){

		return xpath_expr.replace("dummy", new_dummy);
	}

	public Object getWorkspaceData(String xpath_str, QName type) throws XPathExpressionException{
		XPathFactory factory = XPathFactory.newInstance(); 
	    XPath xpath = factory.newXPath(); 
	    XPathExpression expr;
			expr = xpath.compile(xpath_str);
			//expression is evaluated with respect to a certain context node which is doc.
			Object result = null;
			try{
		        result = expr.evaluate(workspace_doc, type);//XPathConstants.NODESET);
			} catch(Exception e){
				
			}

	     return result;
	}
	
	public void addWorkspaceToDocument(){
		//{'WorkspaceProfile':{'CustomTermsets':'null',
		//                     'Termsets':'null',
		//                     'Repositories':'null',
		//                     'Querysets':'null','created':'null','lastchanged':'null','profilename':'null'}};
		Element we = workspace_doc.createElement("WorkspaceProfile");
		we.setAttribute("user", getUsername().toLowerCase());
		workspace_doc.getFirstChild().appendChild(we);
		
		Element e = workspace_doc.createElement("CustomTermsets");
		e.setNodeValue("null");
		we.appendChild(e);
		
		e = workspace_doc.createElement("Termsets");
		e.setNodeValue("null");
		we.appendChild(e);
		
		e = workspace_doc.createElement("Repositories");
		e.setNodeValue("null");
		we.appendChild(e);
		
		e = workspace_doc.createElement("Querysets");
		e.setNodeValue("null");
		we.appendChild(e);
		
		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
		String strdate = dateFormat.format(new Date()).toString();
		e = workspace_doc.createElement("created");
		e.setNodeValue(strdate);
		we.appendChild(e);
		
		e = workspace_doc.createElement("lastchanged");
		e.setNodeValue(strdate);
		we.appendChild(e);
		
		e = workspace_doc.createElement("profilename");
		e.setNodeValue(getUsername().toLowerCase());
		we.appendChild(e);
	}
	
	public InputStream getXMLStream(String xpath_expr) throws XPathExpressionException, TransformerConfigurationException, TransformerException, TransformerFactoryConfigurationError{
		InputStream is;
		NodeList list = (NodeList) getWorkspaceData(xpath_expr, XPathConstants.NODESET);//result;
	    if (list.getLength() < 1) {
	    	addWorkspaceToDocument();
	    	list = (NodeList) getWorkspaceData(xpath_expr, XPathConstants.NODESET);
	    }
	    if (list.getLength() > 1){
	    	// error
	    }
	    // nodelist2stream
	    is = Utils.document2Stream(list.item(0));
	    return is;

	}
	
	//todo .has("Queries")
	public void parseDataInit(JSONObject json){
		// workspaceelement
		if (json.has("Querysets")) {
			this.setQid("0");
			this.setElementtype(WorkspaceProfile.SE_WORKSPACE);
		} else {
			// Querysetelement
			if (json.has("Queries")) {
				this.setElementtype(WorkspaceProfile.SE_QUERYSET);
				this.setQsid(json.getString("id"));
			} else {
				if (json.has("Bookmarks")) {
					this.setElementtype(WorkspaceProfile.SE_BOOKMARKSET);
					this.setQsid(json.getString("id"));
				} else {
					// Query-Bookmark-element
					if (json.getString("bookmark").equals("1")) {
						this.setElementtype(WorkspaceProfile.SE_BOOKMARK);
					} else {
						// Queryelement
						this.setElementtype(WorkspaceProfile.SE_QUERY);
					}
					this.setQid(json.getString("id"));
				}
			}
		}

	}
	
	public String getXMLRootName(){
		String rootname = "WorkspaceProfile";
		if (this.elementtype.equals(WorkspaceProfile.SE_QUERY)){
			rootname = "item";
		}
		if (this.elementtype.equals(WorkspaceProfile.SE_QUERYSET)){
			rootname = "item";
		}
		return rootname;
	}
	
	public  String save(String jsonData) throws ParserConfigurationException, SAXException, IOException, DOMException, XPathExpressionException, TransformerException, TransformerFactoryConfigurationError{
		
        XMLSerializer serializer = new XMLSerializer();
		JSON json = JSONSerializer.toJSON( jsonData );
		// init qid, elementtype
		parseDataInit((JSONObject)json);
		serializer.setRootName(getXMLRootName()); //"WorkspaceProfile");	
		serializer.setElementName("item");
        serializer.setTypeHintsEnabled(false); 
       	String xml = serializer.write( json );
       	//log.debug("XML:" + xml);
       	InputStream is_xml = new ByteArrayInputStream( xml.getBytes( ) );
        // add to document
       	DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document new_doc = builder.parse( is_xml );
        String newid = DocumentReplaceNewElement(new_doc);
      //TODO
        saveDocument();
        
		return newid.toString();
		
	}
	
	public String createNewId(){//String name){
		String name = "maxid";
		String id = workspace_doc.getElementsByTagName(name).item(0).getTextContent();
		Integer i = Integer.parseInt(id) + 1;
		id = i.toString();
		workspace_doc.getElementsByTagName(name).item(0).setTextContent(id);
		return id.toString();
	}
	
	public  String  DocumentReplaceNewElement(Document new_doc) throws XPathExpressionException{
		String newid = "";
		if (this.elementtype.equals(WorkspaceProfile.SE_WORKSPACE)){
			NodeList wsnodelist = (NodeList) getWorkspaceData(this.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_QUERY_PARENT, this.qsid),XPathConstants.NODESET);
	        // remove 
	        //childeNode
	        if (wsnodelist.getLength() > 0){
	        	((Node)wsnodelist.item(0)).getParentNode().removeChild(wsnodelist.item(0));
	        }
	        
	        Node node = new_doc.getFirstChild();
	        Node node2 = workspace_doc.adoptNode(node.cloneNode(true));
	        ((Element)node2).setAttribute("user", this.getUsername());
	        workspace_doc.getElementsByTagName("WorkspaceProfiles").item(0).appendChild(node2);
		}
		if (this.elementtype.equals(WorkspaceProfile.SE_QUERY)){
// new query
			Node node = new_doc.getFirstChild();
			if (this.qid.equals("0")){
				newid = createNewId();//"maxqid");	 
				new_doc.getElementsByTagName("id").item(0).setTextContent(newid);
	 	        Element root = workspace_doc.getDocumentElement();
	 	        Node node2 = workspace_doc.adoptNode(node.cloneNode(true));
	 	        node2 = workspace_doc.renameNode(node2, "", "item");
	 	   // apend to specific queryset
				NodeList wsnodelist = (NodeList) getWorkspaceData(this.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_QUERY_PARENT, this.qsid),XPathConstants.NODESET);;
				Node anode = wsnodelist.item(0);
				if (anode.getTextContent().trim().toLowerCase().equals("null")){
					anode.setTextContent("");
				}
	 	        anode.appendChild(node2);
			} 
			
			else {
				// edit existing query
				NodeList wsnodelist = (NodeList) getWorkspaceData(this.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_WORKSPACE_QUERY, this.qsid),XPathConstants.NODESET);;;
		        // remove 
		        //childeNode
		        if (wsnodelist.getLength() > 0){
		        	//Element root = workspace_doc.getDocumentElement();
		        	Node node2 = workspace_doc.adoptNode(node.cloneNode(true));
		        	node2 = workspace_doc.renameNode(node2, "", "item");
		        	Node qnode  = (Node)wsnodelist.item(0);
		        	//root.replaceChild(node2,(Node)wsnodelist.item(0));	
		        	
		        	Element parentElement = (Element)qnode.getParentNode();
					parentElement.insertBefore(node2, qnode);
					qnode.getParentNode().removeChild(qnode);
					parentElement.normalize();
		        }
			}
		}
		if (this.elementtype.equals(WorkspaceProfile.SE_BOOKMARK)){
			// new bookmark
						Node node = new_doc.getFirstChild();
						if (this.qid.equals("0")){
							newid = createNewId();//"maxbid");	 
							new_doc.getElementsByTagName("id").item(0).setTextContent(newid);
				 	        Element root = workspace_doc.getDocumentElement();
				 	        Node node2 = workspace_doc.adoptNode(node.cloneNode(true));
				 	        node2 = workspace_doc.renameNode(node2, "", "item");
				 	   // apend to specific bookmarkset
							NodeList wsnodelist = (NodeList) getWorkspaceData(this.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_BOOKMARK_PARENT, this.qsid),XPathConstants.NODESET);
							Node anode = wsnodelist.item(0);
							if (anode.getTextContent().trim().toLowerCase().equals("null")){
								anode.setTextContent("");
							}
				 	        anode.appendChild(node2);
						} 
						
						else {
							// edit existing query
							NodeList wsnodelist = (NodeList) getWorkspaceData(this.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_WORKSPACE_QUERY, this.qsid),XPathConstants.NODESET);
					        // remove 
					        //childeNode
					        if (wsnodelist.getLength() > 0){
					        	//Element root = workspace_doc.getDocumentElement();
					        	Node node2 = workspace_doc.adoptNode(node.cloneNode(true));
					        	node2 = workspace_doc.renameNode(node2, "", "item");
					        	Node qnode  = (Node)wsnodelist.item(0);
					        	//root.replaceChild(node2,(Node)wsnodelist.item(0));	
					        	
					        	Element parentElement = (Element)qnode.getParentNode();
								parentElement.insertBefore(node2, qnode);
								qnode.getParentNode().removeChild(qnode);
								parentElement.normalize();
					        }
						}
					}
		//new queryset
		if (this.elementtype.equals(WorkspaceProfile.SE_QUERYSET)){
			// new queryset
						Node node = new_doc.getFirstChild();
						if (this.qsid.equals("0")){
							newid = createNewId();//"maxqsid");	 
							new_doc.getElementsByTagName("id").item(0).setTextContent(newid);
				 	        Element root = workspace_doc.getDocumentElement();
				 	        Node node2 = workspace_doc.adoptNode(node.cloneNode(true));
				 	        node2 = workspace_doc.renameNode(node2, "", "item");
				 	   // apend to specific querysets
				 	        NodeList wsnodelist = (NodeList) getWorkspaceData(this.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_WORKSPACE, this.qsid),XPathConstants.NODESET);
				 	        Element welem = (Element)wsnodelist.item(0);
							Node anode = welem.getElementsByTagName("Querysets").item(0);
							if (anode.getTextContent().trim().toLowerCase().equals("null")){
								anode.setTextContent("");
							}
							anode.appendChild(node2);
						} 
						
						else {
							// edit existing queryset
							NodeList wsnodelist = (NodeList) getWorkspaceData(this.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_QUERYSET, this.qsid),XPathConstants.NODESET);
					        // remove 
					        //childeNode
					        if (wsnodelist.getLength() > 0){
					        	//Element root = workspace_doc.getDocumentElement();
					        	Node node2 = workspace_doc.adoptNode(node.cloneNode(true));
					        	node2 = workspace_doc.renameNode(node2, "", "item");
					        	Node qset  = (Node)wsnodelist.item(0);
					        	
					        	Element parentElement = (Element)qset.getParentNode();
								parentElement.insertBefore(node2, qset);
								qset.getParentNode().removeChild(qset);
								parentElement.normalize();
					        }
						}
					}
		
		//new bookmarkset
		if (this.elementtype.equals(WorkspaceProfile.SE_BOOKMARKSET)){
			// new queryset
						Node node = new_doc.getFirstChild();
						if (this.qsid.equals("0")){
							newid = createNewId();//"maxbsid");	 
							new_doc.getElementsByTagName("id").item(0).setTextContent(newid);
				 	        Element root = workspace_doc.getDocumentElement();
				 	        Node node2 = workspace_doc.adoptNode(node.cloneNode(true));
				 	        node2 = workspace_doc.renameNode(node2, "", "item");
				 	   // apend to specific querysets
				 	        NodeList wsnodelist = (NodeList) getWorkspaceData(this.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_WORKSPACE, this.qsid),XPathConstants.NODESET);
				 	        Element welem = (Element)wsnodelist.item(0);
				 	        Node anode = welem.getElementsByTagName("Bookmarksets").item(0);
				 	       if (anode.getTextContent().trim().toLowerCase().equals("null")){
								anode.setTextContent("");
							}
				 	        anode.appendChild(node2);
						} 
						
						else {
							// edit existing bookmarkset
							NodeList wsnodelist = (NodeList) getWorkspaceData(this.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_BOOKMARKSET, this.qsid),XPathConstants.NODESET);
					        // remove 
					        //childeNode
					        if (wsnodelist.getLength() > 0){
					        	//Element root = workspace_doc.getDocumentElement();
					        	Node node2 = workspace_doc.adoptNode(node.cloneNode(true));
					        	node2 = workspace_doc.renameNode(node2, "", "item");
					        	Node qset  = (Node)wsnodelist.item(0);
					        	
					        	Element parentElement = (Element)qset.getParentNode();
								parentElement.insertBefore(node2, qset);
								qset.getParentNode().removeChild(qset);
								parentElement.normalize();
					        }
						}
					}
		return newid;
	}
	
	//TODO Utils
	public static InputStream createStream(String value) throws TransformerException, TransformerFactoryConfigurationError, ParserConfigurationException, UnsupportedEncodingException{
        DocumentBuilderFactory dbfac = DocumentBuilderFactory.newInstance();
        DocumentBuilder docBuilder = dbfac.newDocumentBuilder();
        Document doc = docBuilder.newDocument();

        ////////////////////////
        //Creating the XML tree
        Element root = doc.createElement("root");
        root.setTextContent(value);
        doc.appendChild(root);
        
        DOMSource source = new DOMSource(doc);   
        StringWriter xmlAsWriter = new StringWriter();   
        StreamResult result = new StreamResult(xmlAsWriter);     
        TransformerFactory.newInstance().newTransformer().transform(source, result);   
          
        // write changes   
        ByteArrayInputStream is = new ByteArrayInputStream(xmlAsWriter.toString().getBytes("UTF-8"));  
           

       return is;


	}
	
}


