package eu.clarin.cmdi.mdservice.proxy;

import java.io.IOException;
import java.net.URL;

import org.apache.log4j.Logger;

import eu.clarin.cmdi.mdservice.internal.CQLParseException;
import eu.clarin.cmdi.mdservice.model.Diagnostic;
import eu.clarin.cmdi.mdservice.model.Query;
import eu.clarin.cmdi.mdservice.model.Repositories;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;


public class SRUProxy extends RepoProxy
{

	private static final long serialVersionUID = 1L;
	
	private String proxy_key = "sru";
	private static Logger log = Logger.getLogger("SRUProxy");		 
	 
	public SRUProxy(Query q) {
		super(q);
		// TODO Auto-generated constructor stub
	}
	 
	@Override
	public String getProxyKey() {				
			return proxy_key;		
	}
	
	@Override
	public void checkParams() {
		// required Params
		// check and set defaults
		if (getParam("operation").equals("")) {
			//getSourceAction().setParam("operation","searchRetrieve");
			getSourceAction().getDiagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "operation");
		}
		if (getParam("version").equals("")) {
			//getSourceAction().setParam("version","1.2");
			getSourceAction().getDiagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "version");
		}
		if (getParam("query").equals("") && getParam("operation").equals("searchRetrieve")) {
			getSourceAction().getDiagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "query");
		}
		if (getParam("scanClause").equals("") && getParam("operation").equals("scan")) {
			getSourceAction().getDiagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "scan");
		}


	}
	
	@Override
	public String getBaseURI() {		
		log.debug("SRU-repositorypath:" + Repositories.getRepositories().getRepositoryPath(getSourceAction().getRepository()));
		String uri = Repositories.getRepositories().getRepositoryPath(getSourceAction().getRepository());//Utils.getConfig).getProperty(getProxyKey() + ".uri");		
		return uri;
	}

	 @Override
	public URL getTargetRequest() throws IOException, CQLParseException {
	        		
			log.debug("SRUP.getQuery:" + getParam("query"));
			log.debug("SRUP.getActionkey:" + getSourceAction().getActionkey());		

		// check if the query could get parsed
			if (getQuery().isStatus(Query.PARSEERROR)) {
				log.debug("SRUP.query.PARSEERROR:" + getQuery().getMsg());
				throw new CQLParseException("SRUP.query.PARSEERROR:" + getQuery().getMsg());
			} else {
		
				URL targetURL = null;
				URL tmp = getBaseURL();
				targetURL =new URL( tmp.toExternalForm() + getQuery().toURLParam());
			
				log.debug("SRUPA.targetURL:" + targetURL);

				return targetURL;
			}
			 
		}
}