package eu.clarin.cmdi.mdservice.proxy;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Map;

import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.xpath.XPathExpressionException;

import org.apache.log4j.Logger;
import org.w3c.dom.NodeList;

import eu.clarin.cmdi.mdservice.action.GenericAction;
import eu.clarin.cmdi.mdservice.internal.CQLParseException;
import eu.clarin.cmdi.mdservice.internal.NoStylesheetException;
import eu.clarin.cmdi.mdservice.internal.Utils;
import eu.clarin.cmdi.mdservice.model.Diagnostic;
import eu.clarin.cmdi.mdservice.model.Diagnostics;
import eu.clarin.cmdi.mdservice.model.Options;
import eu.clarin.cmdi.mdservice.model.Repositories;
import eu.clarin.cmdi.mdservice.model.Termsets;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;


/**
 *
 */
public class WorkspaceProxy extends BasicProxy{

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger("WorkspaceProxy");
 
	private String proxy_key = "workspace";
	
	/**
	 * identification of the target-proxy (type)
	 * base for finding the right base_url in the props
	 * subclass has to override with its specific proxykey
	 * @return
	 */
	public String getProxyKey() {				
			return proxy_key;		
	}


	@Override
	public void checkParams() {
		// required Params
/*
		//if (getParam("q").equals("")) {
		//	getSourceAction().getDiagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "q");
		//}
		if (getParams().get("format") == null){
			if (getSourceAction().getFormat() == null) {
				addParam("format","xml");
			} else if (getSourceAction().getFormat().equals("")){
				addParam("format","xml");
			} else {
				addParam("format",getSourceAction().getFormat());
			}
		} 
		
		addParam("fullformat",getSourceAction().getFullFormat());
		*/
	}
	
	@Override
	public URL getTargetRequest() throws IOException, CQLParseException {
		
	    return null;
		
	}
	
	//http://localhost:8080/MDService2/workspaceprofile/json/server
	//http://localhost:8080/MDService2/repository/json
	//http://localhost:8080/MDService2/options/json
	@Override
	public InputStream getSourceStream() throws IOException, NoStylesheetException, CQLParseException {
		
		//Options.getStream();
		//Repositories.getStream();
		//Termsets.getStream();
		if (getParam("part").equals("repositories")){
			try {
				return Repositories.getRepositories().getXMLStream(getParam("extradata"));
			} catch (TransformerConfigurationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TransformerException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TransformerFactoryConfigurationError e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (getParam("part").equals("options")){
			try {
				return Options.getOptions().getXMLStream();
			} catch (TransformerConfigurationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TransformerException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TransformerFactoryConfigurationError e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (getParam("part").equals("termsets")){
			try {
				return Termsets.getTermsets().getXMLStream();
			} catch (TransformerConfigurationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TransformerException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TransformerFactoryConfigurationError e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		try {
			WorkspaceProfile wsp = WorkspaceProfile.getWorkspaceProfile();
			return wsp.getXMLStream(wsp.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_WORKSPACE, this.getSourceAction().getUserName()));
		} catch (XPathExpressionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TransformerConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TransformerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TransformerFactoryConfigurationError e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	

}	